#include "tga.h"
#include <stdio.h>
#include <windows.h>

int LoadTGAFile(char *filename, TGAFILE *tgaFile) {
	FILE *pFile;
	unsigned char ucharBad; //garbage unsigned char data
	short int			sintBad;  //gargabe short int data
	long					imageSize;
	int						colorMode;
	long					imageIdx;
	unsigned	char	colorSwap;

	pFile = fopen(filename, "rb");
	if (!pFile) return FALSE;

	//unnuetze bytes
	fread(&ucharBad, sizeof(unsigned char),1,pFile);
	fread(&ucharBad, sizeof(unsigned char),1,pFile);

	fread(&tgaFile->imageTypeCode, sizeof(unsigned char),1,pFile);

	if((tgaFile->imageTypeCode != 2) && (tgaFile->imageTypeCode !=3)) {
		fclose(pFile);
		return false;
	}

	fread(&sintBad, sizeof(short int), 1, pFile);
	fread(&sintBad, sizeof(short int), 1, pFile);
	fread(&ucharBad, sizeof(unsigned char),1,pFile);
	fread(&sintBad, sizeof(short int), 1, pFile);
	fread(&sintBad, sizeof(short int), 1, pFile);

	fread(&tgaFile->imageWidth, sizeof(short int), 1, pFile);
	fread(&tgaFile->imageHeight, sizeof(short int), 1, pFile);

	fread(&tgaFile->bitCount, sizeof(unsigned char), 1, pFile);
	fread(&ucharBad, sizeof(unsigned char),1,pFile);
	colorMode = tgaFile->bitCount / 8;
	imageSize = tgaFile->imageWidth * tgaFile->imageHeight * colorMode;

	//allocate memory
	tgaFile->imageData = (unsigned char*)malloc(sizeof(unsigned char)*imageSize);
	fread(tgaFile->imageData, sizeof(unsigned char), imageSize, pFile);

	for(imageIdx = 0; imageIdx < imageSize; imageIdx += colorMode) {
		colorSwap = tgaFile->imageData[imageIdx];
		tgaFile->imageData[imageIdx] = tgaFile->imageData[imageIdx + 2];
		tgaFile->imageData[imageIdx +2] = colorSwap;
	}
	fclose(pFile);
	return true;

}